;+
; NAME: eis_md_packet_header__define.pro
;
; PURPOSE: Definition of the EIS ccsds packet structure
;      
; CATEGORY: Science
;
; CALLING SEQUENCE: None
;
; INPUTS: None
;
; KEYWORD PARAMETERS: None
;
; OUTPUTS: None
;
; CALLS: None
;
; COMMON BLOCKS:None.
;
; PROCEDURE:
;
; RESTRICTIONS: Uses SolarSoft
;
; MODIFICATION HISTORY:
;	23/11/05 mcrw	wrote
;       14/08/06 mcrw	added documentation
;
;-

function eis_md_packet_header::sub_sequence_count

end

function eis_md_packet_header::full_x

end

function eis_md_packet_header::full_y

end

function eis_md_packet_header::base_x

end

function eis_md_packet_header::base_y

end

function eis_md_packet_header::partial_x

end

function eis_md_packet_header::partial_y

end

function eis_md_packet_header::TT1

end

function eis_md_packet_header::TT2

end

function eis_md_packet_header::MHC

end

function eis_md_packet_header::duration

end

function eis_md_packet_header::sequence

end

function eis_md_packet_header::linelist

end

function eis_md_packet_header::sequence_id

end

function eis_md_packet_header::raster_id

end

function eis_md_packet_header::number_of_windows

end

function eis_md_packet_header::coarse_mirror_position

end

function eis_md_packet_header::fine_mirror_position

end

function eis_md_packet_header::sla_position

end

function eis_md_packet_header::OCBX

end

function eis_md_packet_header::OCBY

end

function eis_md_packet_header::rasters_requested

end

function eis_md_packet_header::rasters_completed

end

function eis_md_packet_header::raster_repeats_requested

end

function eis_md_packet_header::raster_repeats_completed

end

function eis_md_packet_header::sequences_requested

end

function eis_md_packet_header::sequences_completed

end

function eis_md_packet_header::read_out_node

end

function eis_md_packet_header::HSL

end

function eis_md_packet_header::OP

end

function eis_md_packet_header::XRT

end

function eis_md_packet_header::XRT_x

end

function eis_md_packet_header::XRT_y

end

function eis_md_packet_header::AEC_hepc

end

function eis_md_packet_header::AEC_lepc

end

function eis_md_packet_header::EXRT_x

end

function eis_md_packet_header::EXRT_y

end

function eis_md_packet_header::FMSG

end

function eis_md_packet_header::EFL_x

end

function eis_md_packet_header::EFL_y

end

function eis_md_packet_header::EEV_x

end

function eis_md_packet_header::EEV_y

end

function eis_md_packet_header::ASRC

end

function eis_md_packet_header::ASRC1

end

function eis_md_packet_header::EP

end

function eis_md_packet_header::FMSS

end


pro eis_md_packet_header::initialise, verbose=verbose
  self.verbose = verbose
;    self.basename = basename
end


; Add things like ccsds s/c time fields. Write out entire header (as sav?).
pro eis_md_packet_header__define

  struct = { eis_md_packet_header, $
             ccsds_header    : bytarr(10),  $
;;;;;;;             md_header_bytes : bytarr(264),  $
             md_header_bytes : bytarr(264),  $
             eis_md_header   : { eis_md_hdr, $
                                 sc_bytes : bytarr(8), $
                                 datatype : 0L, $
;                                  packet_size : 0L, $
                                 serial_packet_number : 0L, $
                                 main_id : 0U, $
                                 main_sequence_flag : 0U, $ ; top 2 bits of main_sequence_count
;                                  main_sequence_count : 0U, $
;                                  reserved : 0B, $
                                 packets_per_exposure : 0U, $ ; shift right 6
                                ;image_per_frame : bottom 6 bits of
;                                         nr_of_packets:0B, $
;                                         img_type:0B, $
                                 sub_id:0U, $
                                 sub_seq_flag:0U, $
;                                  sub_seq_count:0U, $
                                 x_f:0U, $         ; full image size x
                                 y_f:0U, $         ; full image size y
                                 b_x:0U, $         ; x-coord of upper left corner of img
                                 b_y:0U, $         ; y-coord of upper left corner of img
                                 x_p:0U, $         ; partial image size (x)
                                 y_p:0U, $         ; partial image size (y)
;                                  reserved_3:0B, $
                                 bit_compr_mode:0B, $ ; bit compression mode
;                                  img_compr_mode:0B, $        ; image compression mode
;                                  reserved_4:0B, $
;                                  huffman_ac:0B, $        ; Huffman AC table No.
;                                  huffman_dc:0B, $       ; Huffman DC table No.
                                 quant_tab:0B, $ ; Quantization table
                                 exp_info:create_struct(name='exp_info', $
                                                        'ti_1', 0UL, $
                                                        'ti_2', 0UL, $
                                                        'exp_mhc', 0UL, $
                                                        'exp_dur', 0U, $
                                                        'seq_nr', 0B, $
                                                        'll_nr', 0B, $
                                                        'seq_id', 0U, $
                                                        'rast_id', 0U, $
                                                        'll_info0', 0UL, $
                                                        'll_info1', 0UL, $
;                                                         'nwin', 0B, $
;                                                         'ccd_sides', 0B, $
;                                                         'ccd_length', 0U, $
;                                                         'xws', 0U, $
;                                                         'xw', 0U, $
;                                                         'yws', 0U, $
;                                                         'yw', 0U, $
;;;;
                                                         ;;; windows
                                                        'window',0UL, $
                                                        
                                                        'cmirr',0U, $
                                                        'fmirr',0U, $
                                                        
                                                        'slitn',0U, $
                                                        'xocb',0B,$
                                                        'yocb',0B,$
                                                        'ras_req',0UL,$
                                                        'ras_counter',0UL,$
                                                        'ras_reps_req',0UL, $ ; includes reps performed, seq reps req
                                                        'seq_reps', 0B, $
                                                        'ron_ccdbl', 0B, $
                                                        'hsl', 0U, $
                                                        'sci_op',0B,$
                                                        
                                                        'xrt_flare_flag',0B,$
                                                        'xrt_x',0B,$
                                                        'xrt_y',0B,$
                                                        'aec_high',0UL,$
                                                        'aec_low',0UL,$
                                                        'xrt_eis_x',0U,$
                                                        'xrt_eis_y',0U,$
                                                        'strain_gauge', 0U,$
                                                        'eis_flare_trig_x',0U,$
                                                        'eis_flare_trig_y',0U,$
                                                        'eis_flare_loc_x',0U,$
                                                        'eis_flare_loc_y',0U,$
                                                        'asrc_stat',0B,$
                                                        'asrc_skip',0B,$
                                                        'ras_per_pos',0B,$
                                                        'fmir_step_size',0U,$
                                                        'spare',bytarr(137)) $
                               }, $
;             verbose                 : 0,            $
;             fail                    : 0,            $
             
;             io_error                : 0, $
             inherits base_object }
end
