;+
; NAME: eis_md_packet_reader__read.pro
;
; PURPOSE: Definition of the EIS ccsds packet structure
;
; CATEGORY: Science
;
; CALLING SEQUENCE: None
;
; INPUTS: None
;
; KEYWORD PARAMETERS: None
;
; OUTPUTS: None
;
; CALLS: None
;
; COMMON BLOCKS:None.
;
; PROCEDURE:
;
; RESTRICTIONS: Uses SolarSoft
;
; MODIFICATION HISTORY:
;	23/11/05 mcrw	wrote
;       14/08/06 mcrw	added documentation
;
;-

function eis_md_packet_reader::read, ccsds_reader, payload_only=payload_only
  self->trace, 'eis_md_packet_reader::read'
  
;  repeat begin
  !quiet = 0
  message, 'reading', /info
  !quiet = 1
  
;;;  if obj_valid(self.md_packet) then begin
;;;     print, 'eis_md_packet_reader::read destroying previous md packet'
;;;     obj_destroy, *self.md_packet
;;;  endif

  !quiet = 0
  message, 'creating new md packet', /info
  !quiet = 1
  self.md_packet = ptr_new(obj_new('eis_md_packet', verbose=self.verbose, trace=self.trace))
;  help, ccsds_reader
;		packet = ptr_new(obj_new('eis_ccsds_packet'))
                                ;foo =
                                ;*(ccsds_reader)->next_packet(packet)
  !quiet = 0
  message, 'reading header', /info
  !quiet = 1
  got_header = 0
  got_data   = 0
  got_header = self->read_header(ccsds_reader)
  !quiet = 0
  message, 'read header (' + strtrim(string(got_header), 2) + ')', /info
  !quiet = 1

  if got_header then begin
     !quiet = 0
     message, 'reading data', /info
     !quiet = 1
     got_data = self->read_data(ccsds_reader)
     !quiet = 0
     message, 'read data (' + strtrim(string(got_data), 2) + ')', /info
     !quiet = 1
  endif else begin
     
  endelse

;  *(self.md_packet)->debug
;  self.debug
  self.eof = not (got_header and got_data)
  return, got_header and got_data
    
;		*(self.md_packet_reader)->read, ccsds_reader
;		*(self.md_packet_reader)->packet(packet)
;		*(self.exposure)->addPacket, packet
;  endrep until *(ccsds_reader)->last_packet_of_sequence()
;	endrep until *ccsds_reader)->is_last_exposure_packet()
;  print, 'Last exposure packet: ' + strtrim(string(packet->main_sequence_flag()), 2) + ',' + strtrim(string(packet->sub_sequence_flag))
;print, 'eis_md_packet_reader::read LAST PACKET READ'
end
