;+
; NAME: eis_md_raster__debug.pro
;
; PURPOSE: Definition of the main EIS raster structure
;
; CATEGORY: Science
;
; CALLING SEQUENCE: None
;
; INPUTS: None
;
; KEYWORD PARAMETERS: None
;
; OUTPUTS: None
;
; CALLS: None
;
; COMMON BLOCKS:None.
;
; PROCEDURE:
;
; RESTRICTIONS: Uses SolarSoft
;
; MODIFICATION HISTORY:
;	23/11/18 mcrw	wrote
;
;-

pro eis_md_raster::debug
  print, 'eis_md_raster::debug'
  
  prefix = 'eis_md_raster.'
;    print, prefix + 'ccsds_header : ', string(self.ccsds_header, format='(Z02)')
;;;  print, prefix + 'md_header    : ', string(self.md_header, format='(Z02)')
;;;  print, prefix + 'fail         : ', self.fail
  print, prefix + 'error        : ', self.error
  print, prefix + 'verbose      : ', self.verbose
  print, prefix + 'name         : ', self.name
  print, prefix + 'base_version : ', self.base_version
  print, prefix + 'version      : ', self.version

  print
  print
  print
  print, 'Number of exposures: ', *(self.exposure_list)->count()
  print
  
  exposure_list = *(self.exposure_list)
  num_exposures = exposure_list->count()
  print, 'Number of exposures: ', num_exposures
  
  for i = 0, num_exposures - 1 do begin
     exposure = *(exposure_list[i])
     help, exposure
     packet_count = exposure->count()
     help,packet_count
     for packet_number = 0, packet_count - 1 do begin
        packet = *(exposure[packet_number])
;        p = exposure[packet_number]
        help,packet
;        help,p
;        help, *p
        packet->debug
;        *p->debug
     endfor
  endfor
    
end
