;+
; NAME: eis_md_raster__decompress.pro
;
; PURPOSE: Definition of the main EIS raster structure
;
; CATEGORY: Science
;
; CALLING SEQUENCE: None
;
; INPUTS: None
;
; KEYWORD PARAMETERS: None
;
; OUTPUTS: None
;
; CALLS: None
;
; COMMON BLOCKS:None.
;
; PROCEDURE:
;
; RESTRICTIONS: Uses SolarSoft
;
; MODIFICATION HISTORY:
;	23/11/18 mcrw	wrote
;
;-

;pro eis_md_raster::decompress, filename, verbose=verbose, rescued=rescued
pro eis_md_raster::decompress
  self->trace, 'eis_md_raster::decompress'


  
  exposure_list = *(self.exposure_list)
  num_exposures = exposure_list->count()
  print, 'Number of exposures: ', num_exposures
  
  for i = 0, num_exposures - 1 do begin
     exposure = *(exposure_list[i])
     help, exposure
     packet_count = exposure->count()
     help,packet_count
     for packet_number = 0, packet_count - 1 do begin
        packet = *(exposure[packet_number])
;        p = exposure[packet_number]
        help,packet
;        help,p
;        help, *p
;;;        packet->debug
;;;        print, 'CCSDS HEADER: ',
;;;        string((packet->md_header())->ccsds_header(), format='(Z02)')
        packet->decompress
;        *p->debug
     endfor
  endfor



  
;  self.filename = filename
;  if keyword_set(rescued) then self.rescued = rescued
;  if keyword_set(verbose) then self.verbose = verbose
;
;  self.ccsds_reader  = ptr_new(obj_new('eis_ccsds_reader','FRED', 'v1.0', 'eis_ccsds_packet', trace=self.trace))
;;  self.raster_reader = ptr_new(obj_new('eis_md_raster_reader', rescued=rescued, verbose=self.verbose))
;  md_packet_reader   = ptr_new(obj_new('eis_md_packet_reader', rescued=rescued, verbose=self.verbose))
;;  self.raster_reader   = ptr_new(obj_new('eis_md_packet_reader', rescued=rescued, verbose=self.verbose))
;
;  print
;  !quiet = 0
;  message, 'Open file for reading', /info
;  !quiet = 1
;  print
;  if *(self.ccsds_reader)->open_for_reading(filename) then begin
;     !quiet = 0
;     message, 'Opened file for reading', /info
;     !quiet = 1
;     repeat begin
;        if *(md_packet_reader)->read(self.ccsds_reader) then begin
;;           *(md_packet_reader)->decompress
;           self->decompress
;        endif
;     endrep until *(md_packet_reader)->eof()
;
;;     *(self.raster_reader)->read, self.ccsds_reader
;;     *(self.raster_reader)->decompress_raster, self.ccsds_reader
;;     *(self.ccsds_reader)->close_input
;;     self.exposure_list = *(self.raster_reader)->exposure_list()
;;     print
;;     print, 'eis_md_raster::read Got exposures'
;;     print
;;     ;*(self.ccsds_reader)->close_input
;
;  endif else begin
;     !quiet = 0
;     message, 'Couldnt open file', /info
;     !quiet = 1
;     return
;  endelse
;  
;  obj_destroy, *self.ccsds_reader
;  obj_destroy, md_packet_reader

end
